
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Base Classes &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Regular LSTMs" href="LSTM.html" />
    <link rel="prev" title="Models" href="Models.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="current nav bd-sidenav">
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Base Classes
  </a>
 </li>
</ul>
<ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="LSTM.html">
   Regular LSTMs
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="LSTMwithNorm.html">
   LSTMs with normalization
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="LSTMchem.html">
   LSTMs with chemistry
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                

<nav id="bd-toc-nav">
    
</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="base-classes">
<h1>Base Classes<a class="headerlink" href="#base-classes" title="Permalink to this headline">¶</a></h1>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">LSTM_Base</span></code> module. It contains the parent classes of the
models and dataset classes defined in the different LSTM modules.</p>
<p>These classes are just defined here to avoid repetitive redefinition of certain
class methods defined for every model. More attributes could have been defined
here as well but I prefered to keep it simple.</p>
<span class="target" id="module-LSTM_Base"></span><dl class="py class">
<dt class="sig sig-object py" id="LSTM_Base.LSTM_Base">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_Base.</span></span><span class="sig-name descname"><span class="pre">LSTM_Base</span></span><a class="reference internal" href="../_modules/LSTM_Base.html#LSTM_Base"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_Base.LSTM_Base" title="Permalink to this definition">¶</a></dt>
<dd><dl class="py method">
<dt class="sig sig-object py" id="LSTM_Base.LSTM_Base.report">
<span class="sig-name descname"><span class="pre">report</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_Base.html#LSTM_Base.report"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_Base.LSTM_Base.report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a little report with all of the information about the class.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>A string with the report information.</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>str</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM_Base.Dataset_Base">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_Base.</span></span><span class="sig-name descname"><span class="pre">Dataset_Base</span></span><a class="reference internal" href="../_modules/LSTM_Base.html#Dataset_Base"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_Base.Dataset_Base" title="Permalink to this definition">¶</a></dt>
<dd><dl class="py method">
<dt class="sig sig-object py" id="LSTM_Base.Dataset_Base.report">
<span class="sig-name descname"><span class="pre">report</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_Base.html#Dataset_Base.report"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_Base.Dataset_Base.report" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a little report with all of the information about the class.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>A string with the report information.</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_Base.Dataset_Base.time_step_function">
<span class="sig-name descname"><span class="pre">time_step_function</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_Base.html#Dataset_Base.time_step_function"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_Base.Dataset_Base.time_step_function" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for generating a time step when <code class="docutils literal notranslate"><span class="pre">None</span></code> is informed.</p>
<p>This function makes some extremely arbitrary choices, but that are based
on values of <code class="docutils literal notranslate"><span class="pre">time_step</span></code> that are known to work well with the
available datasets.</p>
<p>The function calculates the mean duration of the charge cycles in the
given <code class="docutils literal notranslate"><span class="pre">Battery_list</span></code>, and divides it by <code class="docutils literal notranslate"><span class="pre">2*min_len</span></code> to get the
time_step. The factor 2 is there to ensure that most of the cycles will
have more than <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> points after resampling. It could be lower
or higher, but the results currently obtained for the available datasets
match well the manually tested ones.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><strong>time_step</strong> – The time step [s].</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_Base.Dataset_Base.dataset_info">
<span class="sig-name descname"><span class="pre">dataset_info</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">name</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_Base.html#Dataset_Base.dataset_info"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_Base.Dataset_Base.dataset_info" title="Permalink to this definition">¶</a></dt>
<dd><p>Method for creating and information tuple that can be loaded for
creating a similar dataset in the future.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>name</strong> (<em>str</em>) – The name of the file where the tuple will be dumped.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="Models.html" title="previous page">Models</a>
    <a class='right-next' id="next-link" href="LSTM.html" title="next page">Regular LSTMs</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>